//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
#pragma link "SvgCanvas"
TFormMain *FormMain;
//---------------------------------------------------------------------------
__fastcall TFormMain::TFormMain(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::PaintBoxPaint(TObject *Sender)
{
  // draw white background
  PaintBox->Canvas->Brush->Color = clWhite;
  PaintBox->Canvas->Pen->Color = clWhite;
  PaintBox->Canvas->Rectangle(0, 0, PaintBox->Width, PaintBox->Height);

  AnsiString FileName;
  if (WriteSvg)
    FileName = "picture.svg";
  else
    FileName = "";

  TSvgCanvas *SvgCanvas = new TSvgCanvas(FileName, PaintBox->Canvas);
  try
  {
    DrawPicture(SvgCanvas);
  }
  __finally
  {
    delete SvgCanvas;
  }

  WriteSvg = false;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::DrawPicture(TSvgCanvas *Canvas)
{
  #define LightMask 0x707070
  Canvas->Brush->Style = bsSolid;
  Canvas->Pen->Style = psSolid;
  Canvas->Pen->Width = 2;

  // line
  Canvas->Pen->Color = clYellow;
  Canvas->MoveTo(50, 80);
  Canvas->LineTo(200, 80);

  // rectangle
  Canvas->Pen->Color = clGreen;
  Canvas->Brush->Color = clGreen | LightMask;
  Canvas->Rectangle(250, 50, 450, 120);

  // ellipse
  Canvas->Pen->Color = clRed;
  Canvas->Brush->Color = clRed | LightMask;
  Canvas->Ellipse(50, 150, 200, 220);

  // triangle
  Canvas->Pen->Color = clBlue;
  Canvas->Brush->Color = clBlue | LightMask;
  TPoint Points[3];
  Points[0] = Point(250, 220);
  Points[1] = Point(450, 220);
  Points[2] = Point(350, 150);
  Canvas->Polygon(Points, 3);
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::ButtonSaveSvgClick(TObject *Sender)
{
  WriteSvg = true;
  PaintBox->Invalidate();
}
//---------------------------------------------------------------------------