unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, XPMan, SvgCanvas;

type
  TFormMain = class(TForm)
    PaintBox: TPaintBox;
    Panel: TPanel;
    ButtonSaveSvg: TButton;
    XPManifest: TXPManifest;
    procedure PaintBoxPaint(Sender: TObject);
    procedure ButtonSaveSvgClick(Sender: TObject);
  private
    { Private declarations }
    WriteSvg: Boolean;
    procedure DrawPicture(Canvas: TSvgCanvas);
  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;

implementation

{$R *.dfm}

procedure TFormMain.PaintBoxPaint(Sender: TObject);
var
  SvgCanvas: TSvgCanvas;
  FileName: string;
begin
  // draw white background
  with PaintBox.Canvas do
  begin
    Brush.Color := clWhite;
    Pen.Color := clWhite;
    Rectangle(0, 0, PaintBox.Width, PaintBox.Height);
  end;

  if WriteSvg then
    FileName := 'picture.svg'
  else
    FileName := '';

  SvgCanvas := TSvgCanvas.Create(FileName, PaintBox.Canvas);
  try
    DrawPicture(SvgCanvas);
  finally
    SvgCanvas.Free;
  end;

  WriteSvg := False;
end;

procedure TFormMain.DrawPicture(Canvas: TSvgCanvas);
const
  LightMask = $707070;
var
  Points: array of TPoint;
begin
  with Canvas do
  begin
    Brush.Style := bsSolid;
    Pen.Style := psSolid;
    Pen.Width := 2;

    // line
    Pen.Color := clYellow;
    MoveTo(50, 80);
    LineTo(200, 80);

    // rectangle
    Pen.Color := clGreen;
    Brush.Color := clGreen or LightMask;
    Rectangle(250, 50, 450, 120);

    // ellipse
    Pen.Color := clRed;
    Brush.Color := clRed or LightMask;
    Ellipse(50, 150, 200, 220);

    // triangle
    Pen.Color := clBlue;
    Brush.Color := clBlue or LightMask;
    SetLength(Points, 3);
    Points[0] := Point(250, 220);
    Points[1] := Point(450, 220);
    Points[2] := Point(350, 150);
    Polygon(Points);
  end
end;

procedure TFormMain.ButtonSaveSvgClick(Sender: TObject);
begin
  WriteSvg := True;
  PaintBox.Invalidate;
end;

end.
